clear all
close all
clc

vdata=xlsread('data.xlsx');
time=vdata(:,1);

t1=find(time==1951.75); %1969
t2=find(time==2015.5);
vdata=vdata(t1:t2,:);
q=vdata(:,1);
gdp= vdata(:,2); %GDP
cons= vdata(:,3); % CONS	
invest= vdata(:,4); %INVEST	
resinv= vdata(:,5); %RES_INVEST	
rgdp= vdata(:,6); %RGDP	
pgdp= vdata(:,7); %PGDP	
ffr= vdata(:,8)*100; %FFR	
morrate= vdata(:,9); %MORT_RATE	
hrs= vdata(:,10); %HOURS	
wage= vdata(:,11); %WAGES	
% MORT_DEBT_LEVEL	
debt= vdata(:,12); 
% MORT_DEBT_FLOW	
% HP_Case_Shiller	
% HP_Census_Bureau	
hprice= vdata(:,16);% HP_blend	
pop= vdata(:,17); %CNP16OV	
refi= vdata(:,18); %REFI
rrshock= vdata(:,19); %Romer-Romer monetary shock

hhdebt = vdata(:,20);
corpdebt = vdata(:,21);
recession = vdata(:,22);

trendbandpass= vdata(:,47);

lrgdp= log(gdp./pgdp./pop);
refi=refi./100;

lrcon=log(cons./pgdp./pop);
lrinv=log(invest./pgdp./pop);
lrresinv=log(resinv./pgdp./pop);
inf= diff(log(pgdp));
lrhprice=log(hprice./pgdp);
lrdebt=log(debt./pgdp);

lrhhdebt=log(hhdebt./pgdp);

lrcdebt=log(corpdebt./pgdp);

lpgdp=log(pgdp);

debttogdp=debt./gdp;

ffr=ffr./100;

lambda=10e4;
[tr1,c1]=hpfilter( hhdebt./gdp, lambda);

figure(1)
area(q, recession*(max(hhdebt./gdp)+0.1),'FaceColor',[0.75 0.75 0.75],'EdgeColor','none')
hold on
plot(time(t1:t2), hhdebt./gdp, 'LineWidth', 1.5)
hold on
plot(time(t1:t2), tr1, 'r--', 'LineWidth', 1.5)
hh=vline(1955,'k')
hhh=vline(2007.75,'k')
title('Household debt to GDP')
%axis tight
axis([q(1), q(end), 0, 1])
%legend('debt to gdp', 'trend w/ 10e4', 'trend w/ 10e5', 'trend w/ 10e6');



