clear all
close all
clc

vdata=xlsread('debt_data.xlsx');

date=vdata(:, end-4);
t1=find(date==1951.75); 
t2=find(date==2015.5); 
vdata=vdata(t1:t2,:);

totprtogdp=vdata(:,end);
mortogdp=vdata(:,end-1);
hhdebttogdp=vdata(:,end-2);
cordebttogdp=vdata(:,end-3);
q=vdata(:,end-4);


y=[totprtogdp, hhdebttogdp, mortogdp];
lambda=10e4;
[trend, cycle]=hpfilter(hhdebttogdp,lambda);
[trendm, cyclem]=hpfilter(mortogdp,lambda);
lambda5=2.5*10e4;
[trend5, cycle5]=hpfilter(hhdebttogdp,lambda5);
lambda3=10e3;
[trend3, cycle3]=hpfilter(hhdebttogdp,lambda3);
lambda6=10e6;
[trend6, cycle6]=hpfilter(hhdebttogdp,lambda6);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%ONE SIDED HP FILTER
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[data_hptrendone, data_hpcycleone] = one_sided_hp_filter_kalman(hhdebttogdp,lambda);
[data_hptrendone_s, data_hpcycleone_s]=one_sided_hp_filter_serial(hhdebttogdp,lambda);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%DATA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y=hhdebttogdp;
[r,c]=size(y);
uB=32; % lower bound for BC
lB=64; % upper bound for BC

uM=4; % lower bound for MC %Should we use 2,4,6?
lM=64; % upper bound for MC

data=y;

%%%%%%%%%%%%%%%%%%%%%%%%
K=4*6;  % value of K for the Baxter King bandpass filter 
%Baxter and King recommend using moving average based on six years of data
%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% BC/MC COMPONENTS OF ALL DATA
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
nvar=1;
for i=1:nvar
    %to apply BP filter first need to pad data
    ddata(:,i)=data(2:end,i)-data(1:end-1,i);
    data_pad(:,i)=pad(data(:,i),ddata(:,i),1,K,12);
    %creating BC frequency data
    data_bk(:,i)=bpf(data_pad(:,i),uB,lB,K);
    data_BC(:,i)=data_bk(K+1:rows(data_bk)-K,i);
    %creating MC frequency data
    data_bk2(:,i)=bpf(data_pad(:,i),uM,lM,K);
    data_MC(:,i)=data_bk2(K+1:rows(data_bk)-K,i);
end;


data_MC_trend=data-data_MC;

a=find(q==1952);
figure(8)
subplot(2,1,1)
plot(q(a:end), cycle(a:end)./trend(a:end)*100, q(a:end), data_MC(a:end)./data_MC_trend(a:end)*100, '--',  q(a:end), data_hpcycleone(a:end)./data_hptrendone(a:end)*100, 'k-.', 'LineWidth', 1.5)
legend('HH debt gap, HP filter (baseline)', 'HH debt gap, Bandpass filter', 'HH debt gap, one-sided HP filter' )
hold on
plot(q(a:end), zeros(size(q(a:end))), 'k');
axis tight
subplot(2,1,2)
plot(q(a:end), cycle(a:end)./trend(a:end)*100, q(a:end), cyclem(a:end)./trendm(a:end)*100, '--', q(a:end), (hhdebttogdp(a:end)-1.02*trend(a:end))./(1.02*trend(a:end))*100, '-.',  'LineWidth', 1.5)
legend('HH debt gap, baseline', 'HH debt gap, mortgage debt','HH debt gap, 2 % above trend')
hold on
plot(q(a:end), zeros(size(q(a:end))), 'k');
axis tight

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ndata=xlsread('FRB_FOR.xlsx'); %1980q1-2015q4
dsr=ndata(1:end-1,1);
fobr=ndata(1:end-1,4);

figure(9)
subplot(2,1,1)
a=find(q==1980);
plot(q(a:end), cycle(a:end)./trend(a:end)*100, q(a:end), (dsr-mean(dsr))./mean(dsr)*100, '--', q(a:end), (fobr-mean(fobr))./mean(fobr)*100, '-.', 'LineWidth', 1.5)
legend('HH debt gap', 'Debt service ratio ', 'Financial obligation ratio')
hold on
plot(q(a:end), zeros(size(q(a:end))), 'k');
axis tight
subplot(2,1,2)
a=find(q==1952);
%plot(q(a:end), cycle3(a:end)./trend3(a:end)*100, '-.', q(a:end), cycle(a:end)./trend(a:end)*100, q(a:end), cycle5(a:end)./trend5(a:end)*100, '--',  q(a:end), (hhdebttogdp(a:end)-1.02*trend(a:end))./(1.02*trend(a:end))*100,  'LineWidth', 1.5)
plot(q(a:end), cycle(a:end)./trend(a:end)*100, q(a:end), cycle3(a:end)./trend3(a:end)*100, '-.',  q(a:end), cycle5(a:end)./trend5(a:end)*100, '--',  'LineWidth', 1.5)
legend('HH debt gap (baseline), \lambda= 10e4 ', 'HH debt gap, \lambda= 10e3',  'HH debt gap, \lambda= 10e5')
hold on
plot(q(a:end), zeros(size(q(a:end))), 'k');
axis tight

