function ypad = pad(y,yf,fcode,n,nar);

% -- Pad Data series y out using AR Forecasts and Backcasts
%      y -- series to be padded
%     yf -- data to use in AR (levels or diffs)
%     fcode -- 1 if yf is first dif of y
%              otherwise yf=y
%     n -- number of terms to pad forward and backward
%     nar -- order of autoregression to use


% Pad out future 
w=yf(nar+1:rows(yf));
x=ones(rows(w),1);
i=1; while i<=nar;
 x=[x,yf(nar+1-i:rows(yf)-i)];
i=i+1; end;
beta=(inv(x'*x))*(x'*w);
v=flipud(yf(rows(yf)-nar+1:rows(yf)));
forc=zeros(n,1);
i=1; while i <= n;
 forc(i)=beta'*[1;v];
 v(2:rows(v))=v(1:rows(v)-1);
 v(1)=forc(i);
i=i+1; end;
if fcode == 1;
 forc=cumsum(forc,1) + ones(n,1)*y(rows(y),1);
end;
ypad=[y;forc];

% Pad out past, by reversing series @
yf=flipud(yf);
if fcode == 1;
 yf=-yf;
end;
w=yf(nar+1:rows(yf));
x=ones(rows(w),1);
i=1; while i<=nar;
 x=[x,yf(nar+1-i:rows(yf)-i)];
i=i+1; end;
beta=(inv(x'*x))*(x'*w);
v=flipud(yf(rows(yf)-nar+1:rows(yf)));
forc=zeros(n,1);
i=1; while i <= n;
 forc(i)=beta'*[1;v];
 v(2:rows(v))=v(1:rows(v)-1);
 v(1)=forc(i);
i=i+1; end;
if fcode == 1;
 forc=cumsum(forc,1) + ones(n,1)*y(1,1);
end;
forc=flipud(forc);
ypad=[forc;ypad];


